#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "gun2four4xi.py">
#<abstract4xi abstract = "guns to direction four"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'gun2four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from dummyprocess4xi import DummyProcess4Xi

from shoot2four4xi import shoot2four4xi

from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "

      
#"
#"/>
    
             
# -----------------------------------------------------------------------------------------------------
#<function4xi function = "gun2four4xi" usage = "
#   gun for Process4Xi-4
#"> 
# -----------------------------------------------------------------------------------------------------
       
def gun2four4xi(queue2work, channel2consume, channel2publish):
    '''
    guns for Process4Xi-4
    '''    
        
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    print('=' *33)
    print("(STEP 1/33) OF GUN2FOUR4XI, START TIME: ", time4xi()) 
    print('=' *33)
    # 05:21:05 04/24/13 Pacific Daylight Time
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     

    queue2work4four = queue2work
    
    print('~' *33)
    print("(STEP 2/33) OF GUN2FOUR4XI, QUEUE2WORK4FOUR: ", queue2work4four)
    print('~' *33)
    # <queue4xi.Queue4Xi object at 0x0000000006404B00>
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    channel2consume4four = channel2consume
    print('~' *33)
    print("(STEP 3/33) OF GUN2FOUR4XI, CHANNEL2CONSUME4FOUR: ", channel2consume4four)
    print('~' *33)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000064040B8>
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    channel2publish4four = channel2publish
    print('~' *33)
    print("(STEP 4/33) OF GUN2FOUR4XI, CHANNEL2PUBLISH4FOUR: ", channel2publish4four)
    print('~' *33)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x0000000006404320>
        
    
    # ---------------------------------------------------------------------------------------------    
    # GETTING FROM QUEUE
    # --------------------------------------------------------------------------------------------- 
        
    try:
        message2qet4four = queue2work4four.get()
        print("(STEP 5A/33) OF GUN2FOUR4XI - MESSAGE2QET4FOUR GOT: ", message2qet4four) 
        # <copy4xi>copy2four</copy4xi>
        
        if message2qet4four == "<copy4xi>copy2four</copy4xi>":
            message2put4four = "<roger4xi>roger2four</roger4xi>"
            print("(STEP 5B/33) OF GUN2FOUR4XI - SET MESSAGE2PUT4FOUR TO: ", message2put4four) 
            # <roger4xi>roger2four</roger4xi>
        else:
            print("(STEP 5c/33) OF GUN2FOUR4XI - *** UNREGONIZED MESSAGE GOT: ", message2qet4four)           
            message2put4four = "<negative4xi>negative2four</negative4xi>"
            print("(STEP 5d/33) OF GUN2FOUR4XI - SET MESSAGE2PUT4FOUR TO: ", message2put4four)             
    except:
        message2put4four = "<negative4xi>negative2four</negative4xi>"
    
    
    # ---------------------------------------------------------------------------------------------    
    # PUTTING TO QUEUE
    # --------------------------------------------------------------------------------------------- 
    print("(STEP 6A/33) OF GUN2FOUR4XI - TRYING TO PUT MESSAGE2PUT4FOUR: ", message2put4four)                                  
    # <roger4xi>roger2four</roger4xi>
    try:         
        queue2work4four.put(message2put4four) 
        print('~' *33)
        print("(STEP 6B/33) OF GUN2FOUR4XI - PUT TO QUEUE2WORK4FOUR: ", queue2work4four, ' MESSAGE2PUT4FOUR: ', message2put4four)
        print('~' *33)
        # <queue4xi.Queue4Xi object at 0x0000000006404B00>  MESSAGE2PUT4FOUR:  <roger4xi>roger2four</roger4xi
        
    except:
        print("(STEP 6c/33) OF GUN2FOUR4XI *** FAILED TO PUT TO QUEUE2WORK4FOUR: ", queue2work4four, ' MESSAGE2PUT4FOUR: ', message2put4four)
                   
    # ---------------------------------------------------------------------------------------------    
    # RECEIVING FROM PIPE CONSUMER CHANNEL
    # ---------------------------------------------------------------------------------------------     

    print("(STEP 7A/33) OF GUN2FOUR4XI - TRYING TO RECEIVE FROM CHANNEL2CONSUME4FOUR: ", channel2consume4four)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000064040B8>
    try:
        message2receive4four = channel2consume4four.recv()
        print("(STEP 7B/33) OF GUN2FOUR4XI - RECEIVED MESSAGE2RECEIVE4FOUR: ", message2receive4four)
        # <copy4xi>copy2four</copy4xi>
        
        if message2receive4four == "<copy4xi>copy2four</copy4xi>":
            message2send4four = "<roger4xi>roger2four</roger4xi>"
            print("(STEP 7C/33) OF GUN2FOUR4XI - SET MESSAGE2SEND4FOUR: ", message2send4four)
            # <roger4xi>roger2four</roger4xi>
        else:
            message2send4four = "<negative4xi>negative2four</negative4xi>"
            print("(STEP 7D/33) OF GUN2FOUR4XI - SET MESSAGE2SEND4FOUR: ", message2send4four)        
    except:
        print("(STEP 7E/33) OF GUN2FOUR4XI - *** EXCEPTION WITH CHANNEL2CONSUME4FOUR.RECV: ", channel2consume4four.recv) 
        message2send4four = "<negative4xi>negative2four</negative4xi>"
        print("(STEP 7F/33) OF GUN2FOUR4XI - SET MESSAGE2SEND4FOUR: ", message2send4four)       
            
        
            
    # ---------------------------------------------------------------------------------------------
    # SEND DATA TO THE PIPE'S PUBLISHER CHANNEL 
    # ---------------------------------------------------------------------------------------------
    print("(STEP 8A/33) OF GUN2FOUR4XI - TRYING TO SEND DATA TO CHANNEL2PUBLISHER4FOUR: ", channel2publish4four)
    # <pipeconnection4xi.PipeConnection4Xi object at 0x0000000006404320>
    try:         
        channel2publish4four.send(message2send4four)
        print("(STEP 8B/33) OF GUN2FOUR4XI - SENT MESSAGE2SEND4FOUR: ", message2send4four, " CHANNEL2PUBLISHER4FOUR: ", channel2publish4four)
        # <roger4xi>roger2four</roger4xi>  CHANNEL2PUBLISHER4FOUR:  <pipeconnection4xi.PipeConnection4Xi object at 0x0000000006404320>
    except:
        print("(STEP 8C/33) OF GUN2FOUR4XI - *** FAILED TO SEND MESSAGE2SEND4FOUR: ", message2send4four, " CHANNEL2PUBLISHER4FOUR: ", channel2publish4four) 
    
    # ---------------------------------------------------------------------------------------------    
    # PERFORMING MANOEUVRE 
    # --------------------------------------------------------------------------------------------- 
    print("(STEP 9A/33) OF GUN2FOUR4XI - TRYING MANOEUVRE SPHERE2ENT: (+X,-Y,+Z) - EAST, NORTH, TOWARDS")     
    # (+X,-Y,+Z) - EAST, NORTH, TOWARDS
        
    ack2function = False
    if ack2function is True:
        # -----------------------------------------------------------------------------------------    
        # Using the function to shoot - this approach works, but blocks return to MainProcess4Xi! 
        # -----------------------------------------------------------------------------------------    
    
        try: 
            sphere2ent = shoot2four4xi(start2distance = 100, interval2distance = 100, max2layer = 100, max2count = 200, marginal2count = 1.2, sign2x = '+', sign2y = '-', sign2z = '+',
                                       max2iterate = 4200, increase2distance = None, change2a = pi/60 , change2e = pi/60, increase2a = 0.01, increase2e = 0.01,
                                       start2plusa = 4.712388980384689, max2plusa = 2*pi, min2plusa = pi/240, start2minusa = -pi/6 , max2minusa = -0.98*2*pi, min2minusa = -pi/240,
                                       start2pluse = 1.3235987755982994, max2pluse = pi, min2pluse = pi/240, start2minuse = -pi/6, max2minuse = -0.98*pi, min2minuse = -pi/240)                    
                                       
     
            print("(STEP 9B/33) OF GUN2FOUR4XI - PERFORMED MANOEUVRE SPHERE2ENT: (+X,-Y,+Z) - EAST, NORTH, TOWARDS")
            # for results search (STEP 32/33) OF SHOOT2FOUR4XI - STATISTICS FOR REQUIRED           
        except:
            print("(STEP 9C/33) OF GUN2FOUR4XI *** FAILED TO PERFORM MANOEUVRE SPHERE2ENT: (+X,-Y,+Z) - EAST, NORTH, TOWARDS") 
    else:
        pass
    
    ack2process = True
    if ((ack2process is True) and (ack2function is False)):
        # -----------------------------------------------------------------------------------------    
        # Using the dummy process to shoot - this approach tries faster return to MainProcess4Xi  
        # -----------------------------------------------------------------------------------------      
        print("(STEP 10A/33) OF GUN2FOUR4XI - CREATING A DUMMY PROCESS4XI")  
        ack2dummy = False
        
        # -----------------------------------------------------------------------------------------    
        # create the dummy process object 
        # -----------------------------------------------------------------------------------------          
        # to be checked in test_sphere4xi.txt: OK SHOOTING OF SHOOT2FOUR4XI 
        # example: ACCEPTED SHOTS 87 >= 80  ORIGINALLY REQUIRED, MARIGINAL:  1.2
        try:                            # latest ok shot
            start2distance = 10         # 3300
            interval2distance = 10      # 100 
            max2layer = 10              # 100 
            marginal2layer = 1.2        # 1.2
            max2count = 80              # 100    
         
            marginal2count = 1.2
            sign2x = '+'
            sign2y = '-'
            sign2z = '+'
            max2iterate = 2400
            
            start2plusa = 4.712388980384689
            max2plusa = 2*pi
            min2plusa = pi/240
            start2minusa = -pi/6
            max2minusa = -0.98*2*pi
            min2minusa = -pi/240
            
            start2pluse = 1.3235987755982994
            max2pluse = pi
            min2pluse = pi/240
            start2minuse = -pi/6
            max2minuse = -0.98*pi
            min2minuse = -pi/240
            
            increase2distance = 1
            change2a = pi/60
            change2e = pi/60
            increase2a = 0.01
            increase2e = 0.01        
                    
            dummy2four = DummyProcess4Xi(target=shoot2four4xi, 
                                            args =(queue2work4four,
                                                   channel2consume4four, channel2publish4four,
                                                   start2distance, interval2distance, max2layer, marginal2layer,max2count,
                                                   marginal2count, sign2x, sign2y, sign2z, max2iterate, 
                                                   start2plusa, max2plusa, min2plusa, start2minusa, max2minusa, min2minusa,
                                                   start2pluse, max2pluse, min2pluse, start2minuse, max2minuse, min2minuse,
                                                   increase2distance, change2a, change2e, increase2a, increase2e))
                                                                                                                         
            print("(STEP 10B/33) OF GUN2FOUR4XI - CREATED DUMMY_PROCESS4XI OBJECT DUMMY2FOUR: ", dummy2four)
            # <DummyProcess4Xi(Thread-4, initial)> 
            
            ack2dummy = True
        except:
            print("(STEP 10C/33) OF GUN2FOUR4XI *** FAILED TO CREATE DUMMY_PROCESS4XI OBJECT DUMMY2FOUR ***")
            ack2dummy = False
            
        # -----------------------------------------------------------------------------------------    
        # start the dummy process object
        # -----------------------------------------------------------------------------------------              
        if ack2dummy is True:
            print("(STEP 10D/33) OF GUN2FOUR4XI - STARTING THE DUMMY PROCESS4XI TIME: ", time4xi())  
            ack2start = False
            try:      
                dummy2four.start() 
                print("(STEP 10E/33) OF GUN2FOUR4XI - STARTED THE DUMMY PROCESS4XI DUMMY2FOUR: ", dummy2four)
                # <DummyProcess4Xi(Thread-4, started 6440)>
                ack2start = True
            except:
                print("(STEP 10F/33) OF GUN2FOUR4XI *** FAILED TO START THE DUMMY PROCESS4XI ***")
        else:
            print("(STEP 10G/33) OF GUN2FOUR4XI ** YIELDED STARTING THE DUMMY PROCESS4XI - ACK2DUMMY: ", ack2dummy)
            ack2start = False 
    else:
        print("(STEP 10H/33) OF GUN2FOUR4XI ** YIELDED STARTING THE DUMMY PROCESS4XI - ACK2DUMMY: ", ack2dummy, " ACK2FUNCTION: ", ack2function)
                                
                                                            
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     

    print('=' *33)
    print("(STEP 10/33) OF GUN2FOUR4XI - RETURNING TIME: ", time4xi())
    print('=' *33)
    # 05:21:05 04/24/13 Pacific Daylight Time
    
#</function4xi>
#</program4xi>             
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_sphere4xi.txt
#   sense-test-sphere4xi.xml
#   reason-test-sphere4xi.xml
#   ace-test-sphere4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of gun2four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
